Debian Bug report logs - #664058
dpkg-dev: please add action to dpkg-buildflags to get an overview of the settings

version graph

Package: dpkg-dev; Maintainer for dpkg-dev is Dpkg Developers <debian-dpkg@lists.debian.org>; Source for dpkg-dev is src:dpkg.

Reported by: "Bernhard R. Link" <brlink@debian.org>

Date: Thu, 15 Mar 2012 11:03:02 UTC

Severity: wishlist

Tags: patch

Found in version dpkg/1.16.1.2

Fixed in version dpkg/1.16.5

Done: Guillem Jover <guillem@debian.org>

Bug is archived. No further changes may be made.

Toggle useless messages

View this report as an mbox folder, status mbox, maintainer mbox


Information forwarded to debian-bugs-dist@lists.debian.org, Dpkg Developers <debian-dpkg@lists.debian.org>:
Bug#664058; Package dpkg-dev. (Thu, 15 Mar 2012 11:03:05 GMT) Full text and rfc822 format available.

Acknowledgement sent to "Bernhard R. Link" <brlink@debian.org>:
Extra info received and forwarded to list. Copy sent to Dpkg Developers <debian-dpkg@lists.debian.org>. (Thu, 15 Mar 2012 11:03:09 GMT) Full text and rfc822 format available.

Message #5 received at submit@bugs.debian.org (full text, mbox):

From: "Bernhard R. Link" <brlink@debian.org>
To: submit@bugs.debian.org
Subject: dpkg-dev: please add action to dpkg-buildflags to get an overview of the settings
Date: Thu, 15 Mar 2012 12:00:52 +0100
[Message part 1 (text/plain, inline)]
Package: dpkg-dev
Version: 1.16.1.2
Severity: wishlist
Tags: patch

It would be nice to have some action of dpkg-buildflags to output
the actual compiler flags so maintainers can call this and log
analysers can find that information in the log.
(dpkg-buildflags --dump would hard to identify without false positives
and suggesting to add something like dpkg-buildflags | sed -e
's/^/dpkg-buildflags: /' would surely lead to unneeded variance).

If that would also output the feature flags and some information
why the values get this way (so that one can help new developers
by just looking at some build log instead of requesting each
piece of information manually).

Attached is a patch relative to current dpkg git master to output
environment variables, vendor, feature flags and compiler flags
in a nice way as new action '--status'.

        Bernhard R. Link
[0001-dpkg-buildflags-add-status-action-to-describe-what-i.patch (text/x-diff, attachment)]

Information forwarded to debian-bugs-dist@lists.debian.org, Dpkg Developers <debian-dpkg@lists.debian.org>:
Bug#664058; Package dpkg-dev. (Fri, 16 Mar 2012 08:39:03 GMT) Full text and rfc822 format available.

Acknowledgement sent to Raphael Hertzog <hertzog@debian.org>:
Extra info received and forwarded to list. Copy sent to Dpkg Developers <debian-dpkg@lists.debian.org>. (Fri, 16 Mar 2012 08:39:03 GMT) Full text and rfc822 format available.

Message #10 received at 664058@bugs.debian.org (full text, mbox):

From: Raphael Hertzog <hertzog@debian.org>
To: "Bernhard R. Link" <brlink@debian.org>, 664058@bugs.debian.org
Subject: Re: Bug#664058: dpkg-dev: please add action to dpkg-buildflags to get an overview of the settings
Date: Fri, 16 Mar 2012 09:36:25 +0100
Hi,

the idea seems good, in particular since we had to remove this
from dpkg-buildpackage because the information outputted there could
not be accurate (i.e. no access to DEB_*_MAINT_* variables).

Here's a review so that you can bring your patch in a state where I can
merge it.

On Thu, 15 Mar 2012, Bernhard R. Link wrote:
> --- a/man/dpkg-buildflags.1
> +++ b/man/dpkg-buildflags.1
> @@ -72,6 +72,17 @@ Print the list of flags supported by the current vendor
>  (one per line). See the \fBSUPPORTED FLAGS\fP section for more
>  information about them.
>  .TP
> +.BI \-\-status
> +Print all information to standard output:
> +Environment variables that might have had some influence,
> +the current vendor,
> +the state of all feature flags, and finally
> +all compiler flags together with their origin and values.

Suggestion of a better sentence:

Display any information that can be useful to explain the behaviour
of dpkg-buildflags: relevant environment variables, current vendor,
state of all feature flags. Also print the resulting compiler
flags with their origin.

> +This is intended to be run from debian/rules, so that the log
> +contains all the information or to debug why the flags are that
> +they end up to be.

Reworded:

This is intended to be run from \fBdebian/rules\fP, so that the
build log keeps a clear trace of the build flags used. This can
be useful to diagnose problems related to them.

> --- a/scripts/Dpkg/BuildFlags.pm
> +++ b/scripts/Dpkg/BuildFlags.pm

Please document the fact that you added a new method in the corresponding
section at the end of the file. ($VERSION="1.02" has not been released
yet, otherwise you'd have to increase it to "1.03" and document it there)

> diff --git a/scripts/dpkg-buildflags.pl b/scripts/dpkg-buildflags.pl
> index d0f9fa8..890076b 100755
> --- a/scripts/dpkg-buildflags.pl
> +++ b/scripts/dpkg-buildflags.pl
> @@ -24,6 +24,7 @@ use Dpkg;
>  use Dpkg::Gettext;
>  use Dpkg::ErrorHandling;
>  use Dpkg::BuildFlags;
> +use Dpkg::Vendor qw(get_current_vendor);
>  
>  textdomain("dpkg-dev");
>  
> @@ -52,6 +53,7 @@ Actions:
>                       compilation flags in a shell script, in make,
>                       or on a ./configure command line.
>    --dump             output all compilation flags with their values
> +  --status           informational message about current status

Better:
print a synopsis with all parameters affecting
the behaviour of dpkg-buildflags

> @@ -80,6 +82,10 @@ while (@ARGV) {
>          usageerr(_g("two commands specified: --%s and --%s"), "list", $action)
>              if defined($action);
>          $action = "list";
> +    } elsif (m/^--status$/) {
> +        usageerr(_g("two commands specified: --%s and --%s"), "status", $action)
> +            if defined($action);
> +        $action = "status";

This would be the 3rd copy of the same boiler-plate code. Please merge the
3 copies in one (using /^--(status|list|dump)$/ and later $1 instead of
the hardcode value).

> +} elsif ($action eq "status") {
> +    # prefix everything with "dpkg-buildflags: " to allow easy extraction
> +    # from a buildd log.

IMO this is not the proper way to extract it automatically. If you want
this feature, you should add a unique (and fixed) start/end marker.

Maybe something like this ?

--- BEGIN DPKG-BUILDFLAGS STATUS ---
[…]
--- END DPKG-BUILDFLAGS STATUS ---

If you really want to keep the "dpkg-builflags: " prefix, then you should
use one of the functions exported by Dpkg::ErrorHandling. But I don't
think it's required.

> +    # results: (would be nice to only print those having an effect for
> +    # the current vendor, but getting that information here would be
> +    # quite tough):

You can easily do that... instead of hardcoding it here, create
a new vendor hook for this purpose. Either the vendor hook
allows to extend your @envvars or it prints directly supplementary
information to include...

> +    my @envvars = ('DEB_VENDOR', 'DEB_BUILD_OPTIONS',
> +                   'DEB_BUILD_MAINT_OPTIONS', 'DEB_BUILD_HARDENING');

And indeed I was puzzled by seeing DEB_BUILD_HARDENING but realized thanks
to your comment that it was only relevant for Ubuntu...

> +    foreach my $flag ($build_flags->list()) {
> +	push @envvars, "DEB_" . $flag . "_SET",
> +			"DEB_" . $flag . "_STRIP",
> +			"DEB_" . $flag . "_APPEND",
> +			"DEB_" . $flag . "_PREPEND",
> +			"DEB_" . $flag . "_MAINT_SET",
> +			"DEB_" . $flag . "_MAINT_STRIP",
> +			"DEB_" . $flag . "_MAINT_APPEND",
> +			"DEB_" . $flag . "_MAINT_PREPEND";
> +    }

This list should not be hardcoded at this level but in Dpkg::BuildFlags.
Please create a new method list_envvar() that returns this list and use it
here.

> +	# note that DEB_*_MAINT_* currently is not reflected
> +	# by $origin...

This was on purpose. It's a choice of the maintainer and thus of the
vendor. And since it happens at the end, it would hide any
user/system-wide customization... and I don't want this.

Cheers,
-- 
Raphaël Hertzog ◈ Debian Developer

Pre-order a copy of the Debian Administrator's Handbook and help
liberate it: http://debian-handbook.info/liberation/




Information forwarded to debian-bugs-dist@lists.debian.org, Dpkg Developers <debian-dpkg@lists.debian.org>:
Bug#664058; Package dpkg-dev. (Fri, 16 Mar 2012 10:21:16 GMT) Full text and rfc822 format available.

Acknowledgement sent to "Bernhard R. Link" <brlink@debian.org>:
Extra info received and forwarded to list. Copy sent to Dpkg Developers <debian-dpkg@lists.debian.org>. (Fri, 16 Mar 2012 10:21:20 GMT) Full text and rfc822 format available.

Message #15 received at 664058@bugs.debian.org (full text, mbox):

From: "Bernhard R. Link" <brlink@debian.org>
To: Raphael Hertzog <hertzog@debian.org>
Cc: 664058@bugs.debian.org
Subject: Re: Bug#664058: dpkg-dev: please add action to dpkg-buildflags to get an overview of the settings
Date: Fri, 16 Mar 2012 11:16:53 +0100
[Message part 1 (text/plain, inline)]
* Raphael Hertzog <hertzog@debian.org> [120316 09:36]:
> Suggestion of a better sentence:
> Reworded:

incorporated
> IMO this is not the proper way to extract it automatically. If you want
> this feature, you should add a unique (and fixed) start/end marker.
>
> Maybe something like this ?
>
> --- BEGIN DPKG-BUILDFLAGS STATUS ---
> […]
> --- END DPKG-BUILDFLAGS STATUS ---

Things requiring context like that are no fun to parse at all. You
cannot grep them, a line parser needs additional context.

> If you really want to keep the "dpkg-builflags: " prefix, then you should
> use one of the functions exported by Dpkg::ErrorHandling. But I don't
> think it's required.

That seems to always want to output some extra (at least a colon) and
most even seem to have localized messages, so do not look very
suiteable.

> You can easily do that... instead of hardcoding it here, create
> a new vendor hook for this purpose. Either the vendor hook
> allows to extend your @envvars or it prints directly supplementary
> information to include...

done.

> And indeed I was puzzled by seeing DEB_BUILD_HARDENING but realized thanks
> to your comment that it was only relevant for Ubuntu...

Actually I seem to have read that part to fast. It seems to be a output
and not a input variable...

> > +	# note that DEB_*_MAINT_* currently is not reflected
> > +	# by $origin...
>
> This was on purpose. It's a choice of the maintainer and thus of the
> vendor. And since it happens at the end, it would hide any
> user/system-wide customization... and I don't want this.

Added a patch on top of it to show more information here.

I've split the first one into preparations to the infrastructure and
the --status introduction. If you prefer them merged let me know...

        Bernhard R. Link
[0001-Dpkg-BuildFlags-add-get_feature_areas.patch (text/x-diff, attachment)]
[0002-Dpkg-BuildFlags-record-environment-variables-looked-.patch (text/x-diff, attachment)]
[0003-dpkg-buildflags-add-status-action-to-describe-what-i.patch (text/x-diff, attachment)]
[0004-dpkg-buildflags-make-status-output-which-flags-are-m.patch (text/x-diff, attachment)]

Information forwarded to debian-bugs-dist@lists.debian.org, Dpkg Developers <debian-dpkg@lists.debian.org>:
Bug#664058; Package dpkg-dev. (Fri, 16 Mar 2012 11:09:03 GMT) Full text and rfc822 format available.

Acknowledgement sent to Raphael Hertzog <hertzog@debian.org>:
Extra info received and forwarded to list. Copy sent to Dpkg Developers <debian-dpkg@lists.debian.org>. (Fri, 16 Mar 2012 11:09:04 GMT) Full text and rfc822 format available.

Message #20 received at 664058@bugs.debian.org (full text, mbox):

From: Raphael Hertzog <hertzog@debian.org>
To: "Bernhard R. Link" <brlink@debian.org>
Cc: 664058@bugs.debian.org
Subject: Re: Bug#664058: dpkg-dev: please add action to dpkg-buildflags to get an overview of the settings
Date: Fri, 16 Mar 2012 12:07:36 +0100
On Fri, 16 Mar 2012, Bernhard R. Link wrote:
> > IMO this is not the proper way to extract it automatically. If you want
> > this feature, you should add a unique (and fixed) start/end marker.
> >
> > Maybe something like this ?
> >
> > --- BEGIN DPKG-BUILDFLAGS STATUS ---
> > […]
> > --- END DPKG-BUILDFLAGS STATUS ---
> 
> Things requiring context like that are no fun to parse at all. You
> cannot grep them, a line parser needs additional context.

┏rivendell:~/x/c-a
┗(582)$ cat  ~/tmp/test.txt
before
START
1
2
3
END
after
┏rivendell:~/x/c-a
┗(583)$ sed -ne '/^START/,/^END/ p' ~/tmp/test.txt
START
1
2
3
END

Really it's not difficult.

> > If you really want to keep the "dpkg-builflags: " prefix, then you should
> > use one of the functions exported by Dpkg::ErrorHandling. But I don't
> > think it's required.
> 
> That seems to always want to output some extra (at least a colon) and
> most even seem to have localized messages, so do not look very
> suiteable.

Well, dpkg-buildflags can output additional errors/warnings during the
build so your grep would catch those too. You're thus not able to extract
only the output of the status command.

So if you don't want to go for the above, you should at least use
“print report("status", …)” so that the output ends up always starting
with "dpkg-buildflags: status: " and this can be reasonably extracted
too.

> I've split the first one into preparations to the infrastructure and
> the --status introduction. If you prefer them merged let me know...

It's ok.

> +=item $bf->environment_used($envvar)
> +
> +Records that the given environment variable had influenced
> +or could have influenced (if it had existed or had a different
> +value) the calculated flags.
> +
> +=cut

Please pick a name that start with an action. "mark_used_environment"
or "mark_used_envvar" maybe.

> +sub environment_used {
> +    my ($self, $envvar) = @_;
> +    $self->{'used_envs'}->{$envvar} = 1;

The second "->" is not needed. Drop it.

> +=item my @list = $bf->get_used_environment()

Be consistent with the former method, don't use once "environment_used" and
once "use_environment". Thus I suggest "get_used_environment" or
"get_used_envvar".

Also please return a sorted list to make the order non-random.

> +    my @envvars = $build_flags->get_used_environment();
> +    for my $envvar (@envvars) {
> +	if (exists $ENV{$envvar}) {
> +	    printf "dpkg-buildflags: environment variable %s=%s\n",
> +				$envvar, $ENV{$envvar};
> +	}
> +    }

BTW, I don't really like the usage of plain english in the output.
Plain english ought to be translated... maybe we can use somewhat
meaningful prefixes ?

E: for environment (or ENV:?)
V: for vendor (or VENDOR: ?)
F: for feature (or FEATURE:?)
R: for result or (or RES:? or FLAG:?)

It also makes it easier to reliably extract a sub-part of the output...

> From 6a600d3f9d2b438ca59d0e81f69b91249bd197b1 Mon Sep 17 00:00:00 2001
> From: "Bernhard R. Link" <brlink@debian.org>
> Date: Fri, 16 Mar 2012 11:05:17 +0100
> Subject: [PATCH 4/4] dpkg-buildflags: make --status output which flags are
>  modified by maintainer
> 
> As flags modified by DEB_*_MAINT_* are not reflected by its origin, add
> a new flag to describe flags modified that way.

Do you really see some value to this? You already have the *_MAINT_* variables
in the output.

I don't believe that this is required.

Cheers,
-- 
Raphaël Hertzog ◈ Debian Developer

Pre-order a copy of the Debian Administrator's Handbook and help
liberate it: http://debian-handbook.info/liberation/




Information forwarded to debian-bugs-dist@lists.debian.org, Dpkg Developers <debian-dpkg@lists.debian.org>:
Bug#664058; Package dpkg-dev. (Fri, 16 Mar 2012 17:54:09 GMT) Full text and rfc822 format available.

Acknowledgement sent to "Bernhard R. Link" <brlink@debian.org>:
Extra info received and forwarded to list. Copy sent to Dpkg Developers <debian-dpkg@lists.debian.org>. (Fri, 16 Mar 2012 17:54:09 GMT) Full text and rfc822 format available.

Message #25 received at 664058@bugs.debian.org (full text, mbox):

From: "Bernhard R. Link" <brlink@debian.org>
To: Raphael Hertzog <hertzog@debian.org>
Cc: 664058@bugs.debian.org
Subject: Re: Bug#664058: dpkg-dev: please add action to dpkg-buildflags to get an overview of the settings
Date: Fri, 16 Mar 2012 18:49:26 +0100
[Message part 1 (text/plain, inline)]
* Raphael Hertzog <hertzog@debian.org> [120316 12:07]:
> ┗(583)$ sed -ne '/^START/,/^END/ p' ~/tmp/test.txt
>
> Really it's not difficult.

It is not impossible and might not be difficult, but it complicates
things a lot without any need.

> So if you don't want to go for the above, you should at least use
> “print report("status", …)” so that the output ends up always starting
> with "dpkg-buildflags: status: " and this can be reasonably extracted
> too.

Is that required? As this is something to have some fixed format to
allow automatic extraction, I'd really prefer to not make it use
something for another purpose that might change the output in the
future.
(the environment stuff might use it, but then the output would get
inconsistent).

> > +    my @envvars = $build_flags->get_used_environment();
> > +    for my $envvar (@envvars) {
> > +	if (exists $ENV{$envvar}) {
> > +	    printf "dpkg-buildflags: environment variable %s=%s\n",
> > +				$envvar, $ENV{$envvar};
> > +	}
> > +    }
>
> BTW, I don't really like the usage of plain english in the output.
> Plain english ought to be translated... maybe we can use somewhat
> meaningful prefixes ?
>
> E: for environment (or ENV:?)
> V: for vendor (or VENDOR: ?)
> F: for feature (or FEATURE:?)
> R: for result or (or RES:? or FLAG:?)
>
> It also makes it easier to reliably extract a sub-part of the output...

as long as the output format is fixed, it does not make it easier to parse,
only harder to understand for humans.

everything else incorporated.

> > As flags modified by DEB_*_MAINT_* are not reflected by its origin, add
> > a new flag to describe flags modified that way.
>
> Do you really see some value to this? You already have the *_MAINT_* variables
> in the output.
>
> I don't believe that this is required.

It's not required but it might help people a lot to understand it.
Maintainers are humans, too, and getting "vendor" here after you
successfully changed it is a bit confusing (as logical as it is when
going one step back and looking at it).

        Bernhard R. Link
[0002-Dpkg-BuildFlags-record-environment-variables-looked-.patch (text/x-diff, attachment)]
[0003-dpkg-buildflags-add-status-action-to-describe-what-i.patch (text/x-diff, attachment)]

Information forwarded to debian-bugs-dist@lists.debian.org, Dpkg Developers <debian-dpkg@lists.debian.org>:
Bug#664058; Package dpkg-dev. (Mon, 19 Mar 2012 10:12:05 GMT) Full text and rfc822 format available.

Acknowledgement sent to "Bernhard R. Link" <brlink@debian.org>:
Extra info received and forwarded to list. Copy sent to Dpkg Developers <debian-dpkg@lists.debian.org>. (Mon, 19 Mar 2012 10:12:07 GMT) Full text and rfc822 format available.

Message #30 received at 664058@bugs.debian.org (full text, mbox):

From: "Bernhard R. Link" <brlink@debian.org>
To: Raphael Hertzog <hertzog@debian.org>
Cc: 664058@bugs.debian.org
Subject: Re: Bug#664058: dpkg-dev: please add action to dpkg-buildflags to get an overview of the settings
Date: Mon, 19 Mar 2012 11:09:19 +0100
[Message part 1 (text/plain, inline)]
* Raphael Hertzog <hertzog@debian.org> [120316 09:36]:
> Please document the fact that you added a new method in the
> corresponding section at the end of the file. ($VERSION="1.02"
> has not been released yet, otherwise you'd have to increase it
> to "1.03" and document it there)

I undestand that since 1.16.2 was released in between, I need
to change the version? Attached are new versions of this patches
with the version changed.

        Bernhard R. Link
[0001-Dpkg-BuildFlags-add-get_feature_areas.patch (text/x-diff, attachment)]
[0002-Dpkg-BuildFlags-record-environment-variables-looked-.patch (text/x-diff, attachment)]
[0003-dpkg-buildflags-add-status-action-to-describe-what-i.patch (text/x-diff, attachment)]
[0004-dpkg-buildflags-make-status-output-which-flags-are-m.patch (text/x-diff, attachment)]

Information forwarded to debian-bugs-dist@lists.debian.org, Dpkg Developers <debian-dpkg@lists.debian.org>:
Bug#664058; Package dpkg-dev. (Mon, 19 Mar 2012 10:39:03 GMT) Full text and rfc822 format available.

Acknowledgement sent to Raphael Hertzog <hertzog@debian.org>:
Extra info received and forwarded to list. Copy sent to Dpkg Developers <debian-dpkg@lists.debian.org>. (Mon, 19 Mar 2012 10:39:09 GMT) Full text and rfc822 format available.

Message #35 received at 664058@bugs.debian.org (full text, mbox):

From: Raphael Hertzog <hertzog@debian.org>
To: "Bernhard R. Link" <brlink@debian.org>
Cc: 664058@bugs.debian.org
Subject: Re: Bug#664058: dpkg-dev: please add action to dpkg-buildflags to get an overview of the settings
Date: Mon, 19 Mar 2012 11:37:45 +0100
On Mon, 19 Mar 2012, Bernhard R. Link wrote:
> I undestand that since 1.16.2 was released in between, I need
> to change the version? Attached are new versions of this patches
> with the version changed.

Yes, thank you.

Guillem, what's your opinion on the output of the --status command?

Bernhard and I seem to have different preference for it (start/end marker
vs fixed prefix on all lines).

Cheers,
-- 
Raphaël Hertzog ◈ Debian Developer

Pre-order a copy of the Debian Administrator's Handbook and help
liberate it: http://debian-handbook.info/liberation/




Information forwarded to debian-bugs-dist@lists.debian.org, Dpkg Developers <debian-dpkg@lists.debian.org>:
Bug#664058; Package dpkg-dev. (Mon, 04 Jun 2012 13:28:08 GMT) Full text and rfc822 format available.

Acknowledgement sent to Raphael Hertzog <hertzog@debian.org>:
Extra info received and forwarded to list. Copy sent to Dpkg Developers <debian-dpkg@lists.debian.org>. (Mon, 04 Jun 2012 13:28:16 GMT) Full text and rfc822 format available.

Message #40 received at 664058@bugs.debian.org (full text, mbox):

From: Raphael Hertzog <hertzog@debian.org>
To: "Bernhard R. Link" <brlink@debian.org>
Cc: 664058@bugs.debian.org, guillem@debian.org
Subject: Re: Bug#664058: dpkg-dev: please add action to dpkg-buildflags to get an overview of the settings
Date: Mon, 4 Jun 2012 15:14:12 +0200
Hi,

On Mon, 19 Mar 2012, Raphael Hertzog wrote:
> On Mon, 19 Mar 2012, Bernhard R. Link wrote:
> > I undestand that since 1.16.2 was released in between, I need
> > to change the version? Attached are new versions of this patches
> > with the version changed.
> 
> Yes, thank you.
> 
> Guillem, what's your opinion on the output of the --status command?
> 
> Bernhard and I seem to have different preference for it (start/end marker
> vs fixed prefix on all lines).

Guillem, any opinion?

Cheers,
-- 
Raphaël Hertzog ◈ Debian Developer

Get the Debian Administrator's Handbook:
→ http://debian-handbook.info/get/




Information forwarded to debian-bugs-dist@lists.debian.org, Dpkg Developers <debian-dpkg@lists.debian.org>:
Bug#664058; Package dpkg-dev. (Tue, 05 Jun 2012 13:24:11 GMT) Full text and rfc822 format available.

Acknowledgement sent to "Bernhard R. Link" <brlink@debian.org>:
Extra info received and forwarded to list. Copy sent to Dpkg Developers <debian-dpkg@lists.debian.org>. (Tue, 05 Jun 2012 13:24:11 GMT) Full text and rfc822 format available.

Message #45 received at 664058@bugs.debian.org (full text, mbox):

From: "Bernhard R. Link" <brlink@debian.org>
To: Raphael Hertzog <hertzog@debian.org>
Cc: 664058@bugs.debian.org
Subject: Re: Bug#664058: dpkg-dev: please add action to dpkg-buildflags to get an overview of the settings
Date: Tue, 5 Jun 2012 15:01:55 +0200
* Raphael Hertzog <hertzog@debian.org> [120604 15:14]:
> > Bernhard and I seem to have different preference for it (start/end marker
> > vs fixed prefix on all lines).

If you say what you want it to look like, I can also prepare some
patches doing the way you want.

Also is there any reason to already get the first two patches with the
infrastructure groundwork already applied?

Is there any chance to still get this into wheezy?

        Bernhard R. Link




Information forwarded to debian-bugs-dist@lists.debian.org, Dpkg Developers <debian-dpkg@lists.debian.org>:
Bug#664058; Package dpkg-dev. (Tue, 05 Jun 2012 18:27:03 GMT) Full text and rfc822 format available.

Acknowledgement sent to Guillem Jover <guillem@debian.org>:
Extra info received and forwarded to list. Copy sent to Dpkg Developers <debian-dpkg@lists.debian.org>. (Tue, 05 Jun 2012 18:27:03 GMT) Full text and rfc822 format available.

Message #50 received at 664058@bugs.debian.org (full text, mbox):

From: Guillem Jover <guillem@debian.org>
To: "Bernhard R. Link" <brlink@debian.org>, 664058@bugs.debian.org
Subject: Re: Bug#664058: dpkg-dev: please add action to dpkg-buildflags to get an overview of the settings
Date: Tue, 5 Jun 2012 20:24:47 +0200
On Tue, 2012-06-05 at 15:01:55 +0200, Bernhard R. Link wrote:
> If you say what you want it to look like, I can also prepare some
> patches doing the way you want.
> 
> Also is there any reason to already get the first two patches with the
> infrastructure groundwork already applied?

Nope, they look good, I've applied them locally and will be on my next
push targetting 1.16.4.

> Is there any chance to still get this into wheezy?

I think so, I'll look into this for 1.16.5 the latest.

thanks,
guillem




Information forwarded to debian-bugs-dist@lists.debian.org, Dpkg Developers <debian-dpkg@lists.debian.org>:
Bug#664058; Package dpkg-dev. (Fri, 08 Jun 2012 08:15:05 GMT) Full text and rfc822 format available.

Acknowledgement sent to Guillem Jover <guillem@debian.org>:
Extra info received and forwarded to list. Copy sent to Dpkg Developers <debian-dpkg@lists.debian.org>. (Fri, 08 Jun 2012 08:15:06 GMT) Full text and rfc822 format available.

Message #55 received at 664058@bugs.debian.org (full text, mbox):

From: Guillem Jover <guillem@debian.org>
To: "Bernhard R. Link" <brlink@debian.org>, 664058@bugs.debian.org
Subject: Re: Bug#664058: dpkg-dev: please add action to dpkg-buildflags to get an overview of the settings
Date: Fri, 8 Jun 2012 09:49:39 +0200
On Tue, 2012-06-05 at 20:24:47 +0200, Guillem Jover wrote:
> On Tue, 2012-06-05 at 15:01:55 +0200, Bernhard R. Link wrote:
> > If you say what you want it to look like, I can also prepare some
> > patches doing the way you want.
> > 
> > Also is there any reason to already get the first two patches with the
> > infrastructure groundwork already applied?
> 
> Nope, they look good, I've applied them locally and will be on my next
> push targetting 1.16.4.

I ended up pulling them out and deferred them for 1.16.5, these are
the first thing I'll be looking at for the next release cycle.

thanks,
guillem




Added tag(s) pending. Request was from Guillem Jover <guillem@debian.org> to control@bugs.debian.org. (Sat, 30 Jun 2012 04:57:02 GMT) Full text and rfc822 format available.

Message sent on to "Bernhard R. Link" <brlink@debian.org>:
Bug#664058. (Sat, 30 Jun 2012 04:57:46 GMT) Full text and rfc822 format available.

Message #60 received at 664058-submitter@bugs.debian.org (full text, mbox):

From: Guillem Jover <guillem@debian.org>
To: 664058-submitter@bugs.debian.org
Subject: Bug#664058 marked as pending
Date: Sat, 30 Jun 2012 04:53:46 +0000
tag 664058 pending
thanks

Hello,

Bug #664058 reported by you has been fixed in the Git repository. You can
see the changelog below, and you can check the diff of the fix at:

    http://git.debian.org/?p=dpkg/dpkg.git;a=commitdiff;h=ae43199

---
commit ae4319936099f377f9786dd7b33468d32238eb11
Author: Bernhard R. Link <brlink@debian.org>
Date:   Thu Mar 15 11:25:39 2012 +0100

    dpkg-buildflags: Add --status action to describe the flag settings
    
    It's hard to see from a build log file what values should have been
    used and why. The new --status action added by this patch tries to
    output all meaningful information in a way useful for human consumption
    and for automatic log parsers.
    
    [guillem@debian.org:
     - Mark dpkg-buildflags as bold in man page and escape dash.
     - Use report("status", string). ]
    
    Closes: #664058
    
    Signed-off-by: Bernhard R. Link <brlink@debian.org>
    Signed-off-by: Guillem Jover <guillem@debian.org>

diff --git a/debian/changelog b/debian/changelog
index 86f39d0..83c1bf7 100644
--- a/debian/changelog
+++ b/debian/changelog
@@ -15,6 +15,10 @@ dpkg (1.16.5) UNRELEASED; urgency=low
     patches to be kept applied after build (used by formats "2.0" and "3.0
     (quilt)"). Closes: #643043
 
+  [ Guillem Jover ]
+  * Add a dpkg-buildflags --status action to describe the flag settings.
+    Thanks to Bernhard R. Link <brlink@debian.org>. Closes: #664058
+
   [ Updated dpkg translations ]
   * Swedish (Peter Krefting).
 




Reply sent to Guillem Jover <guillem@debian.org>:
You have taken responsibility. (Sat, 30 Jun 2012 05:21:25 GMT) Full text and rfc822 format available.

Notification sent to "Bernhard R. Link" <brlink@debian.org>:
Bug acknowledged by developer. (Sat, 30 Jun 2012 05:21:25 GMT) Full text and rfc822 format available.

Message #65 received at 664058-close@bugs.debian.org (full text, mbox):

From: Guillem Jover <guillem@debian.org>
To: 664058-close@bugs.debian.org
Subject: Bug#664058: fixed in dpkg 1.16.5
Date: Sat, 30 Jun 2012 05:17:51 +0000
Source: dpkg
Source-Version: 1.16.5

We believe that the bug you reported is fixed in the latest version of
dpkg, which is due to be installed in the Debian FTP archive:

dpkg-dev_1.16.5_all.deb
  to main/d/dpkg/dpkg-dev_1.16.5_all.deb
dpkg_1.16.5.dsc
  to main/d/dpkg/dpkg_1.16.5.dsc
dpkg_1.16.5.tar.xz
  to main/d/dpkg/dpkg_1.16.5.tar.xz
dpkg_1.16.5_amd64.deb
  to main/d/dpkg/dpkg_1.16.5_amd64.deb
dselect_1.16.5_amd64.deb
  to main/d/dpkg/dselect_1.16.5_amd64.deb
libdpkg-dev_1.16.5_amd64.deb
  to main/d/dpkg/libdpkg-dev_1.16.5_amd64.deb
libdpkg-perl_1.16.5_all.deb
  to main/d/dpkg/libdpkg-perl_1.16.5_all.deb



A summary of the changes between this version and the previous one is
attached.

Thank you for reporting the bug, which will now be closed.  If you
have further comments please address them to 664058@bugs.debian.org,
and the maintainer will reopen the bug report if appropriate.

Debian distribution maintenance software
pp.
Guillem Jover <guillem@debian.org> (supplier of updated dpkg package)

(This message was generated automatically at their request; if you
believe that there is a problem with it please contact the archive
administrators by mailing ftpmaster@debian.org)


-----BEGIN PGP SIGNED MESSAGE-----
Hash: SHA1

Format: 1.8
Date: Sat, 30 Jun 2012 04:28:51 +0200
Source: dpkg
Binary: libdpkg-dev dpkg dpkg-dev libdpkg-perl dselect
Architecture: source amd64 all
Version: 1.16.5
Distribution: unstable
Urgency: low
Maintainer: Dpkg Developers <debian-dpkg@lists.debian.org>
Changed-By: Guillem Jover <guillem@debian.org>
Description: 
 dpkg       - Debian package management system
 dpkg-dev   - Debian package development tools
 dselect    - Debian package management front-end
 libdpkg-dev - Debian package management static library
 libdpkg-perl - Dpkg perl modules
Closes: 64642 440094 558095 621763 624000 627333 640676 643043 652970 664058 672723 673190 675333 676232 677631 678933 679010
Changes: 
 dpkg (1.16.5) unstable; urgency=low
 .
   [ Raphaël Hertzog ]
   * dpkg-source will now clean up after a failed application of a quilt
     patch. Closes: #652970
     And it will display a message explaining the most likely cause of
     failure (patch applying with fuzz).
   * When dpkg-source regenerates the automatic patch (with formats "2.0"
     or "3.0 (quilt)") it will keep the current patch header to avoid
     losing changes made by the maintainer.
   * Modify dpkg-source --commit to auto-whitelist modified binary files.
     That way the same command can be used whatever kind of upstream files
     has been modified.
   * dpkg-source now supports a new option --no-unapply-patches to force
     patches to be kept applied after build (used by formats "2.0" and "3.0
     (quilt)"). Closes: #643043
 .
   [ Guillem Jover ]
   * Add a dpkg-buildflags --status action to describe the flag settings.
     Thanks to Bernhard R. Link <brlink@debian.org>. Closes: #664058
   * Add support for “binary-only” key-value option in changelogs, to allow
     marking changelog entries as part of a binary only upload, having a
     different version from the source package. Closes: #440094, #672723
   * Minimize source architecture list on «dpkg-source -b» by removing
     architectures already covered by architecture wildcards. Closes: #675333
   * Do not assume $ENV{'HOME'} is defined in Dpkg::Source::Package.
     Thanks to Niels Thykier <niels@thykier.net>. Closes: #677631
   * Document in more detail in deb(5) the supported ar archive format.
   * Document in deb-src-control(5) the “Private-” field prefix.
   * Add new start-stop-daemon --no-close option to disable closing file
     descriptors on --background. Closes: #627333, #64642
   * Switch source compression to xz.
   * Detect ar header fields truncation due to too long member names or too
     large member sizes. Closes: #678933
   * Add new dpkg-query --control-list and --control-show commands, which
     replace the now deprecated --control-path.
   * Print master and slave alternarive link names in update-alternatives
     --query and always print alternative link in --config. Closes: #679010
   * Cleanup and clarify buffer I/O error reporting. Closes: #621763
   * Avoid full stop and double newline at the end of errors and warnings.
     Thanks to Jonathan Nieder <jnieder@gmail.com>. Closes: #624000
   * Change all programs to accept -? instead of -h for help output.
   * Add support for specific arch-qualified dependencies. Closes: #676232
     Thanks to Thibaut Girka <thib@sitedethib.com>.
   * Accept “:native” arch-qualified Build-Dependencies. Closes: #558095
     Thanks to Thibaut Girka <thib@sitedethib.com>.
   * Do not use undefined values returned form deps_parse() in dpkg-shlibdeps.
     Closes: #640676
   * Add an Architecture column to «dpkg-query -l» before the Description
     column. Suggested by Jonathan Nieder <jnieder@gmail.com>. Closes: #673190
 .
   [ Updated dpkg translations ]
   * Swedish (Peter Krefting).
 .
   [ Updated dselect translations ]
   * Swedish (Peter Krefting).
 .
   [ Updated scripts translations ]
   * German (Helge Kreutzmann).
 .
   [ Updated man page translations ]
   * German (Helge Kreutzmann).
   * Swedish (Peter Krefting).
Checksums-Sha1: 
 5e256018148d50da61a19da0cbce49f65cd03169 1372 dpkg_1.16.5.dsc
 e3aaf08015bab5c40980f36514152102556b76b2 3546160 dpkg_1.16.5.tar.xz
 d826663e329d140f38ddfc4353b937cb270c6688 666932 libdpkg-dev_1.16.5_amd64.deb
 c078e1861151da90049e7ce788cb513b769e2e0f 2266848 dpkg_1.16.5_amd64.deb
 ea065b58a7aa49771a275e4e26a7603b65becadf 1100228 dselect_1.16.5_amd64.deb
 c1e214b79282fb56eaa54ad8f2a1dc2daad64eef 1142828 dpkg-dev_1.16.5_all.deb
 085f8ee024365882d641e60e209cc3bfca43bd36 852954 libdpkg-perl_1.16.5_all.deb
Checksums-Sha256: 
 3a4eec53e585abcb15c71f08331da63610150f4858793bc68ee2df006d1da8a6 1372 dpkg_1.16.5.dsc
 fcd8d846479f3f955e1f1facc4422aed6c3173b6c5acd904d9db60f24bc18e7b 3546160 dpkg_1.16.5.tar.xz
 aba88af2256caef0fdd345ba9eeacff8d2013a07b045d5b7c93162bd0893c10b 666932 libdpkg-dev_1.16.5_amd64.deb
 1a56e13f5fc11eabb5ea7d17852cb1b3b09a117b16803e5b9a64ec14b3f37a62 2266848 dpkg_1.16.5_amd64.deb
 50ac49b8115e6d19148031ecec7f976c69a084504c42b860abd1470e63b1f5d0 1100228 dselect_1.16.5_amd64.deb
 7a23dd256195eec9f1ce2297737747a27a8c6d3beba5c9e8e9ac8d8734f07f54 1142828 dpkg-dev_1.16.5_all.deb
 d77dc62deb89a923952c533b2320130d9573e8c3ebfa09fbdf80c835ca30ef65 852954 libdpkg-perl_1.16.5_all.deb
Files: 
 571bd79d38407d605f7559cf65347c01 1372 admin required dpkg_1.16.5.dsc
 c70412c8b0f3609680104585ddb4ba5c 3546160 admin required dpkg_1.16.5.tar.xz
 49221981d6f3490ddc87c8a03bbe332d 666932 libdevel optional libdpkg-dev_1.16.5_amd64.deb
 d9128c702529b095fda97b205bf03398 2266848 admin required dpkg_1.16.5_amd64.deb
 3eed99660309c9fba61b490c057deb78 1100228 admin optional dselect_1.16.5_amd64.deb
 3c7266174c297984846a6eb88ae3730f 1142828 utils optional dpkg-dev_1.16.5_all.deb
 848633279951281c6213f877251081e3 852954 perl optional libdpkg-perl_1.16.5_all.deb

-----BEGIN PGP SIGNATURE-----
Version: GnuPG v1.4.12 (GNU/Linux)

iEYEARECAAYFAk/uhA4ACgkQuW9ciZ2SjJvLqACgvBBdkE81qC2iEsdk4lhVoilv
hd8AoI/JlSVaR2i+DU9dLBBvCWo9RvWC
=xtFu
-----END PGP SIGNATURE-----





Bug archived. Request was from Debbugs Internal Request <owner@bugs.debian.org> to internal_control@bugs.debian.org. (Mon, 20 Aug 2012 07:27:17 GMT) Full text and rfc822 format available.

Send a report that this bug log contains spam.


Debian bug tracking system administrator <owner@bugs.debian.org>. Last modified: Sun Apr 20 23:29:20 2014; Machine Name: beach.debian.org

Debian Bug tracking system
Copyright (C) 1999 Darren O. Benham, 1997,2003 nCipher Corporation Ltd, 1994-97 Ian Jackson.